unit Tip5Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics,
  Controls, Forms, Dialogs, Grids, ExtCtrls, DBCtrls, DBGrids,
  DB, DBTables, StdCtrls;

type
  TFrmMain = class(TForm)
    TblClients: TTable;
    SrcClients: TDataSource;
    GrdClients: TDBGrid;
    NavClients: TDBNavigator;
    TblClientsLAST_NAME: TStringField;
    TblClientsFIRST_NAME: TStringField;
    TblClientsADDRESS_1: TStringField;
    TblClientsCITY: TStringField;
    TblClientsSTATE: TStringField;
    TblClientsZIP: TStringField;
    TblClientsRISK_LEVEL: TStringField;
    Label1: TLabel;
    procedure GrdClientsDrawDataCell( Sender : TObject;
                                      const Rect : TRect;
                                      Field : TField;
                                      State : TGridDrawState );
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}

procedure TFrmMain.GrdClientsDrawDataCell(Sender: TObject;
  const Rect: TRect; Field: TField; State: TGridDrawState);
begin
  (* The if clause below could also be written as
  if TblClients.FieldByName( 'RISK_LEVEL' ).AsString = 'HIGH' then
    ...
  *)

  if TblClientsRISK_LEVEL.AsString = 'HIGH' then
  begin
    GrdClients.Canvas.Font.Color := clRed;
    GrdClients.DefaultDrawDataCell( Rect, Field, State );
  end;
end;

end.
