unit Tip9main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, Tabs, Spin;

type
  TFrmMain = class(TForm)
    Panel2: TPanel;
    TabSet1: TTabSet;
    NbkMain: TNotebook;
    Panel1: TPanel;
    BtnCreate: TButton;
    PnlMain: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    CbxType: TComboBox;
    CbxDest: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    EdtCaption: TEdit;
    Label6: TLabel;
    SpnLeft: TSpinEdit;
    SpnTop: TSpinEdit;
    Label7: TLabel;
    Label8: TLabel;
    procedure TabSet1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure BtnCreateClick(Sender: TObject);
  private
    { Private declarations }
    procedure ClearControls;
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}

procedure TFrmMain.TabSet1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  NbkMain.PageIndex := NewTab;
end;

procedure TFrmMain.ClearControls;
begin
  CbxType.ItemIndex := -1;
  CbxDest.ItemIndex := -1;
  SpnLeft.Value := 50;
  SpnTop.Value := 100;
  EdtCaption.Clear;
end;

procedure TFrmMain.BtnCreateClick( Sender : TObject );
var
  NewControl : TControl;
  Text       : array[ 0..255 ] of Char;
begin
         { Create the component instance with the Form as Owner }
  case CbxType.ItemIndex of
    0: NewControl := TButton.Create( Self );
    1: NewControl := TEdit.Create( Self );
    2: NewControl := TCheckBox.Create( Self );
    3: NewControl := TListBox.Create( Self );
  end;

                           { Specify the new component's Parent }
  case CbxDest.ItemIndex of
    0: NewControl.Parent := Self;
    1: NewControl.Parent := PnlMain;          { Panel is Parent }

                                   { Use current page as Parent }
    2: NewControl.Parent :=
         TWinControl( NbkMain.Pages.Objects[ NbkMain.PageIndex ] );
  end;

  NewControl.Left := SpnLeft.Value;              { Set Position }
  NewControl.Top := SpnTop.Value;

           { Use the wm_SetText message to set the text/caption }
  if NewControl is TWinControl then
  begin
    StrPCopy( Text, EdtCaption.Text );
    SendMessage( TWinControl( NewControl ).Handle, wm_SetText, 0,
                 Longint( @Text ) );
  end;

  ClearControls;
end;

end.
