unit Tip2Tool;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics,
  Controls, Forms, Dialogs, Buttons;

type
  TFrmToolPalette = class(TForm)
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    procedure FormCreate(Sender: TObject);
  private
  public
    procedure CreateParams( var Params: TCreateParams ); override;
    procedure WMGetMinMaxInfo( var Msg : TWMGetMinMaxInfo );
      message wm_GetMinMaxInfo;
  end;

var
  FrmToolPalette: TFrmToolPalette;

implementation

{$R *.DFM}

uses
  Tip2Main;


procedure TFrmToolPalette.FormCreate( Sender : TObject );
begin
  Width := 59;
end;

procedure TFrmToolPalette.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams( Params );
  Params.WndParent := FrmMain.Handle;   { Reference Main Window }
end;

procedure TFrmToolPalette.WMGetMinMaxInfo(var Msg:TWMGetMinMaxInfo);
begin
  Msg.MinMaxInfo^.ptMinTrackSize := Point( 20, 20 );
end;

end.
