unit Tip8main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls;

type
  TFrmMain = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    LblNoFormat: TLabel;
    BtnNoFormat: TButton;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    LblFormat: TLabel;
    BtnFormat: TButton;
    procedure FormCreate(Sender: TObject);
    procedure BtnFormatClick(Sender: TObject);
    procedure BtnNoFormatClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}

procedure TFrmMain.FormCreate(Sender: TObject);
begin
  LblFormat.Caption := 'This is a multi-line'#13 +
                       'label that has been formatted.'#13#13 +
                       'That is,'#13 +
                       'the developer indicates where'#13 +
                       'the line breaks are.';
end;

procedure TFrmMain.BtnFormatClick(Sender: TObject);
var
  FileName : string;
  Msg      : string;
begin
  FileName := 'C:\WINDOWS\SAMPLE.TXT';
  Msg := Format( 'File: %s'#13'Could not be found.'#13#13 +
                 'Please make sure path is correct.', [FileName] );
  MessageDlg( Msg, mtError, [ mbOk ], 0 );
end;

procedure TFrmMain.BtnNoFormatClick(Sender: TObject);
var
  FileName : string;
  Msg      : string;
begin
  FileName := 'C:\WINDOWS\SAMPLE.TXT';
  Msg := Format( 'File: %s Could not be found. ' +
                 'Please make sure path is correct.', [FileName] );
  MessageDlg( Msg, mtError, [ mbOk ], 0 );
end;

end.
