unit Tp10Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DB, DBTables, Grids, DBGrids;

type
  TFrmMain = class(TForm)
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    GrdEmp: TDBGrid;
    TblEmp: TTable;
    SrcEmp: TDataSource;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure GrdEmpKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}

procedure TFrmMain.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    if not ( ( ActiveControl is TCustomGrid ) or
             ( ActiveControl is TCustomMemo ) ) then
    begin
      Key := #0;
      PostMessage( Handle, wm_NextDlgCtl, 0, 0 );
    end
    else if ( ActiveControl is TCustomGrid ) then
      Key := #9;   { Prevents Grid from displaying Field Editor }
  end;
end;

procedure TFrmMain.GrdEmpKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_Return then
  begin
    if GrdEmp.SelectedIndex < Pred( GrdEmp.FieldCount ) then
      GrdEmp.SelectedIndex := GrdEmp.SelectedIndex + 1
    else                                  { At last grid column }
    begin
      GrdEmp.SelectedIndex := 0;
      GrdEmp.Perform( wm_KeyDown, vk_Down, 0 );
    end;
  end;
end;

end.
